### 实验十二 连接WIFI制作网络时钟

#### 网络时间协议

NTP，Network Time Protocol （网络时间协议）是一种网络协议，用于系统和数据网络之间的时间同步。NTP框架依赖于Internet时间服务器。NTP具有精确调整时间的算法。NTP服务器可以通过UDP端口号123将时钟发送到客户端计算机的软件。

我们可以通过连接WIFI进而脸上阿里云的网络时间协议站获取网络时间。

#### 代码讲解

 要想连接上WIFI，我们可以使用Arduino自带的WIFI库，使用这个库可以轻松连上WIFI。

例如烧录以下代码可以连接WIFI然后获取网络时间并保持然后在串口不断打印出当前时间。

![image-20221206132320808](E:\派哟项目\Hexbot项目\HEXBot_使用手册\ESP32使用手册\实验十二 连接WIFI\连接WIFI制作网络时钟.png)

需要注意的使这些函数

**getLocalTime(&timeinfo)**

获取当前时间

**WiFi.begin(ssid, password);**

WIFI的初始化函数，后面两个参数第一个是WIFI名称，第二个是WIFI密码

**WiFi.status()** 

返回连接状态，返回的参数有很多

**configTime(gmtOffset_sec, daylightOffset_sec, ntpServer)**

网络时间连接，参数分别为长度，默认值和网址

**WiFi.disconnect(true);**

判断WIFI的连接状态

 **WiFi.mode(WIFI_OFF);**

WIFI模式配置，连接与否

 **printLocalTime();**

打印当前时间

#### 程序源码

```
#include <WiFi.h>

const char *ssid = "zhouxiandheng";   //你的网络名称

const char *password = "12345678"; //你的网络密码

const char *ntpServer = "time.pool.aliyun.com";

const long gmtOffset_sec = 8 * 3600;

const int daylightOffset_sec = 0;

void printLocalTime()

{

  struct tm timeinfo;

  if (!getLocalTime(&timeinfo))

  {

    Serial.println("Failed to obtain time");

    return;

  }

  Serial.println(&timeinfo, "%F %T %A"); // 格式化输出

}

void setup()

{

  Serial.begin(115200);

  Serial.println();

  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED)

  {

    delay(500);

    Serial.print(".");

  }

  Serial.println("WiFi connected!");

  // 从网络时间服务器上获取并设置时间

  // 获取成功后芯片会使用RTC时钟保持时间的更新

  configTime(gmtOffset_sec, daylightOffset_sec, ntpServer);

  printLocalTime();

  WiFi.disconnect(true);

  WiFi.mode(WIFI_OFF);

  Serial.println("WiFi disconnected!");

}
void loop()

{
  delay(1000);

  printLocalTime();

}
```

